indexing

	description: "Field Content-Length"

	author: "Berend de Boer"
	date: "$Date: 2003/01/09 $"
	revision: "$Revision: #1 $"


class

	EPX_MIME_FIELD_CONTENT_LENGTH


inherit

	EPX_MIME_STRUCTURED_FIELD


creation

	make



feature -- Initialization

	make (a_length: INTEGER) is
			-- Initialize Content-Length.
		require
			length_not_negative: a_length >= 0
		do
			length := a_length
		ensure
			length_set: length = a_length
		end


feature -- State

	name: STRING is "Content-Length"
			-- Authorative name.

	length: INTEGER
			-- Number of bytes in body.

	value: STRING is
			-- Value of a field.
		do
			Result := length.out
		end


invariant

	length_not_negative: length >= 0

end
