indexing

	description: "Converts strings to pointers and vice versa. VisualEiffel 4.1 specification"
	thanks: "The mico/E team for the idea."

	date: "$Date: 2003/11/29 $"
	revision: "$Revision: #6 $"

class

	EPX_STRING_HELPER


inherit

	ABSTRACT_STRING_HELPER


feature -- VisualEiffel specific conversions

	pointer_to_string (p: POINTER): STRING is
		do
			create Result.make_empty
			if p /= default_pointer then
				Result.from_c (p)
			end
		end

	set_string_from_pointer (s: STRING; p: POINTER) is
		do
			if p = default_pointer then
				s.wipe_out
			else
				s.from_c (p)
			end
		end


feature {NONE} -- Implementation

	clear_unsaved_strings is
			-- The strings in `saved_strings' must be released to the
			-- garbage collector upon `unfreeze_all'.
		do
			saved_strings.clear_all
			saved_strings.resize (0, -1)
		end

	do_string_to_pointer (s: STRING): POINTER is
			-- A pointer to a linear area containing all the data
			-- in `s'. The area is zero-terminated.
			-- 's'.count should be equal to `s'.byte_count.
		do
			Result := s.to_pointer
		end

	do_uc_string_to_pointer (s: UC_STRING): POINTER is
			-- A pointer to a linear area containing all the data
			-- in the Unicode string `s'.
			-- Currently getting such a pointer is not an operation
			-- directly supported by UC_STRING and we need to do
			-- different things for certain compilers.
		local
			real_s: STRING
		do
			-- VE must have a real STRING.
			real_s := s.as_string
			Result := real_s.to_pointer
			-- A big issue now is to keep `real_s' alive until the next
			-- `unfreeze_all'.
			saved_strings.force (real_s, saved_strings.upper + 1)
		end

end
